#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from Cheetah.compat import unicode
from xpdeint.Geometry.BesselDimensionRepresentation import BesselDimensionRepresentation

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '3.1.0'
__CHEETAH_versionTuple__ = (3, 1, 0, 'final', 1)
__CHEETAH_genTime__ = 1547125165.000000
__CHEETAH_genTimestamp__ = 'Thu, 10 Jan 2019 12:59:25 -0200'
__CHEETAH_src__ = 'BesselNeumannDimensionRepresentation.tmpl'
__CHEETAH_srcLastModified__ = 'Wed Nov 27 21:44:05 2013'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class BesselNeumannDimensionRepresentation(BesselDimensionRepresentation):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(BesselNeumannDimensionRepresentation, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def gridAndStepAtIndex(self, index, **KWS):



        ## CHEETAH: generated from @def gridAndStepAtIndex($index) at line 24, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write(u'''const real mSquaredFactor = ''')
        if self._order == 0: # generated from line 27, col 3
            write(u'''1.0''')
        else: # generated from line 29, col 3
            write(u'''1.0 - ''')
            _v = VFFSL(SL,"_order",True) # u'${_order}' on line 30, col 7
            if _v is not None: write(_filter(_v, rawExpr=u'${_order}')) # from line 30, col 7.
            write(u''' * ''')
            _v = VFFSL(SL,"_order",True) # u'${_order}' on line 30, col 19
            if _v is not None: write(_filter(_v, rawExpr=u'${_order}')) # from line 30, col 19.
            write(u''' / (_besseljzeros_''')
            _v = VFFSL(SL,"parent.name",True) # u'${parent.name}' on line 30, col 46
            if _v is not None: write(_filter(_v, rawExpr=u'${parent.name}')) # from line 30, col 46.
            write(u'''[''')
            _v = VFFSL(SL,"index",True) # u'${index}' on line 30, col 61
            if _v is not None: write(_filter(_v, rawExpr=u'${index}')) # from line 30, col 61.
            write(u'''] * _besseljzeros_''')
            _v = VFFSL(SL,"parent.name",True) # u'${parent.name}' on line 30, col 87
            if _v is not None: write(_filter(_v, rawExpr=u'${parent.name}')) # from line 30, col 87.
            write(u'''[''')
            _v = VFFSL(SL,"index",True) # u'${index}' on line 30, col 102
            if _v is not None: write(_filter(_v, rawExpr=u'${index}')) # from line 30, col 102.
            write(u'''])''')
        write(u''';
''')
        # 
        _v = super(BesselNeumannDimensionRepresentation, self).gridAndStepAtIndex(index)
        if _v is not None: write(_filter(_v))
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def stepWeightAtIndex(self, index, **KWS):



        ## CHEETAH: generated from @def stepWeightAtIndex($index) at line 38, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write(u'''2.0 / (mSquaredFactor * besselFactor * besselFactor * _besseljS_''')
        _v = VFFSL(SL,"parent.name",True) # u'${parent.name}' on line 40, col 65
        if _v is not None: write(_filter(_v, rawExpr=u'${parent.name}')) # from line 40, col 65.
        write(u''' * _besseljS_''')
        _v = VFFSL(SL,"parent.name",True) # u'${parent.name}' on line 40, col 92
        if _v is not None: write(_filter(_v, rawExpr=u'${parent.name}')) # from line 40, col 92.
        write(u''') * ''')
        _v = VFFSL(SL,"name",True) # u'${name}' on line 40, col 110
        if _v is not None: write(_filter(_v, rawExpr=u'${name}')) # from line 40, col 110.
        write(u'''_max * ''')
        _v = VFFSL(SL,"name",True) # u'${name}' on line 40, col 124
        if _v is not None: write(_filter(_v, rawExpr=u'${name}')) # from line 40, col 124.
        write(u'''_max''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        # BesselNeumannDimensionRepresentation.tmpl
        # 
        # Created by Graham Dennis on 2013-11-27.
        # 
        # Copyright (c) 2013, Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write(u'''

''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_BesselNeumannDimensionRepresentation = 'writeBody'

## END CLASS DEFINITION

if not hasattr(BesselNeumannDimensionRepresentation, '_initCheetahAttributes'):
    templateAPIClass = getattr(BesselNeumannDimensionRepresentation,
                               '_CHEETAH_templateClass',
                               Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(BesselNeumannDimensionRepresentation)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://cheetahtemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=BesselNeumannDimensionRepresentation()).run()


